%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 10/1999
%
% convmkdft.m
%
% Matrix Convolution
% 
%   Recebe:
%		data - dados para convolucao
%		  dimensoes esperadas (nesta ordem):
%		    size_conv
%         size_same
%			 size_contract
%         size_expand_data
%
%		kernel - kernel da convolucao
%		  dimensoes esperadas (nesta ordem):
%		    size_conv
%         size_same
%			 size_contract
%         size_expand_kernel
%
%		dim - tamanho das dimensoes esperadas
%		  conv
%		  same
%		  contract
%       expand_data
%       expand_kernel
%
%   Retorna:
%		result - resultado da convolucao
%		  dimensoes retornadas (nesta ordem):
%		    size_conv
%		    size_same
%			 size_expand_data
%			 size_expand_kernel
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=convm_fft(data,kernel,dim)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%result_convm=convm(data,kernel,dim); 
%dim
%disp('data size');
%ndsize(data)
%disp('kernel size');
%ndsize(kernel)

size_data=ndsize(data);
size_kernel=ndsize(kernel);
size_dft=[size_data{1:dim.conv}]+[size_kernel{1:dim.conv}]-1;
kernel.data=fft0n(kernel.data,size_dft);
result=convmkdft(data,kernel,dim);

%maxall(abs(result_convm.data-result.data))

