%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 10/1999
%
% fdw.m
%
%   Recebe:
%		pre - ativacoes pre
%		  dimensoes esperadas:
%		    size_conv
%         size_pat
%         size_pre
%
%		pos - erros pos
%		  dimensoes esperadas:
%		    size_conv
%         size_pat
%         size_pos
%
%		w - kernel de pesos (w)
%
%   Retorna:
%		result - valores de atualizacao para os pesos (dw)
%		  dimensoes retornadas (nesta ordem):
%		    size_conv
%			 size_pre
%			 size_pos
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=fdw(pre,pos,w,fft)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
permute_pre=[w.permute_pre.conv,w.permute_pre.pat,w.permute_pre.pre];
permute_pos=[w.permute_pos.conv,w.permute_pos.pat,w.permute_pos.pos];
permute_result=[w.permute_w.conv,w.permute_w.pre,w.permute_w.pos];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% inicio - permute
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pre.data=permute(pre.data,permute_pre);
pos.data=permute(pos.data,permute_pos);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% pre:        |conv|pat|pre|
% pos:        |conv|pat|pos|
% result (w): |conv|pre|pos|
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
size_w=ndSize(w);

n_average=size_w(1:w.conv);
n_average=prod([n_average{:}]);

dim.conv=w.conv;
dim.same=0;
dim.contract=w.pat;
dim.expand_data=w.pre;
dim.expand_kernel=w.pos;

for ind_flip=1:w.conv
   pre.data=flipdim(pre.data,ind_flip);
end

if(fft)
   tmp=convm_fft(pre,pos,dim);
else
   tmp=convm(pre,pos,dim);
end

ind_tmp_min=num2cell(ones(tmp.dim));
ind_tmp_max=ndsize(tmp);
for ind=1:w.conv
   ind_tmp_min{ind}=floor(((ind_tmp_max{ind}-ind_tmp_min{ind})-(size_w{ind}-1))/2)+1;
   ind_tmp_max{ind}=ind_tmp_min{ind}+size_w{ind}-1;
end
ind_tmp=ndRange(ind_tmp_min,ind_tmp_max);
ind_result=ndAll(size_w);

result.data(ind_result{:})=tmp.data(ind_tmp{:});%/prod_size_dw;
result.dim=size(size_w,2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fim - ipermute
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
result.data=ipermute(result.data,permute_result);
