%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Julio M. Otuyama - 01/2000
%
% ndProd.m
%
% Produto de array multidimensional
% 
%   Recebe:
%		A
%		  dimensoes esperadas (nesta ordem):
%         size_same
%			 size_contract
%         size_expand_A
%
%		B
%		  dimensoes esperadas (nesta ordem):
%         size_same
%			 size_contract
%         size_expand_B
%
%		dim - tamanho das dimensoes esperadas
%		  same
%		  contract
%       expand_A
%       expand_B
%
%   Retorna:
%		result - resultado do produto
%		  dimensoes retornadas (nesta ordem):
%		    size_same
%			 size_expand_A
%			 size_expand_B
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [result]=ndprod(A,B,dim)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if((dim.same<0)|(dim.expand_A<0)|(dim.expand_B<0)|(dim.contract<0))
   error('ndprod: dimesao negativa invalida');
end;

%dim
%disp('A size');
%ndsize(A)
%disp('B size');
%ndsize(B)

% size A,B
size_A=ndSize(A);
size_B=ndSize(B);
size_same={size_A{1:dim.same}};
size_contract={size_A{dim.same+1:dim.same+dim.contract}};
size_expand_A={size_A{+dim.same+dim.contract+1:dim.same+dim.contract+dim.expand_A}};
size_expand_B={size_B{dim.same+dim.contract+1:dim.same+dim.contract+dim.expand_B}};

% result
size_result={size_same{:},size_expand_A{:},size_expand_B{:}};
result.data=zeros(size_result{:});
result.dim=size(size_result,2);

%
ind_same=ndAll(size_same);

% loop expand A
ind_expand_A=ndFirst(size_expand_A); % first element
while(1) 
   %disp('expand A');
   % loop expand B
   ind_expand_B=ndFirst(size_expand_B); % first element
   while(1) 
      %disp('expand B');
      % loop contract
      ind_contract=ndFirst(size_contract); % first element
      while(1)
         
         %disp('contract');
         %disp([ind_same{:},ind_expand_A{:},ind_contract{:}]);
         %disp([ind_same{:},ind_expand_B{:},ind_contract{:}]);
         %disp([ind_same{:},ind_expand_A{:},ind_expand_B{:}]);
         
         ind_A={ind_same{:},ind_contract{:},ind_expand_A{:}};
         ind_B={ind_same{:},ind_contract{:},ind_expand_B{:}};
         ind_result={ind_same{:},ind_expand_A{:},ind_expand_B{:}};
         
         result.data(ind_result{:})=result.data(ind_result{:})+A.data(ind_A{:}).*B.data(ind_B{:});
         
         [ind_contract,overflow]=ndNext(ind_contract,size_contract); % next element
         if(overflow) break; end % end loop
      end 
      [ind_expand_B,overflow]=ndNext(ind_expand_B,size_expand_B); % next element
      if(overflow) break; end % end loop
   end
   [ind_expand_A,overflow]=ndNext(ind_expand_A,size_expand_A); % next element
   if(overflow) break; end % end loop
end
